Detect CloudFlare (Chromium port)
===============================

An extension for Chromium-based browsers which aims to detect whether the current page uses CloudFlare.  
It adds an icon to the browser toolbar which indicates the detection status.

This is intended to help users detect which of the sites they visit is using CloudFlare, so that they can take the appropriate actions (e.g. changing their password) if they are worried that they are affected by the [cloudbleed bug](https://bugs.chromium.org/p/project-zero/issues/detail?id=1139).

**Note**: This extension detects whether the page _currently_ uses CloudFlare. It cannot detect whether the page might have used CloudFlare in the past, especially during the time period where it was affected by cloudbleed (i.e. 2016-09-22 thru 2017-02-18). For this, you may check [this list](https://github.com/pirate/sites-using-cloudflare).


Installation
------------

The extension is not available (yet) on Chrome's WebStore. To install the extension from source:

* Clone or download this repository
* In your browser, go to [chrome://extensions](chrome://extensions)
* Enable "developer mode" - there should be a toggle on the top right for it
* Click "load unpacked extension" and choose the folder where you cloned or downloaded the repository
* The extension will be loaded. Note that it won't have automatic updates. You might have to pin it to keep it always visible.


How it Works
------------

The extension analyzes all HTTP(S) requests and checks whether any of them are served by CloudFlare proxies, as identified by certain headers in the HTTP(S) response. Based on the result of this analysis, the icon changes color:

![green](icons/cf-green-32.png) No requests were served by CloudFlare.

![orange](icons/cf-orange-32.png) Extenal resources were served by CloudFlare.

![red](icons/cf-red-32.png) The page itself was served by CloudFlare.

Clicking on the icon will show a popup with detailed information about the domains which use CloudFlare.  
Because the extension only uses the headers provided by the server to determine whether a website uses CloudFlare or not, it doesn't make any additional connection to other servers, APIs or DNS resolvers.


Notes
-----

* This extension analyzes **all** requests made by the browser, though other extensions (e.g. adblockers) may block some requests before they are made.
* When navigating forward/backward inside a tab, the detection status will reset to neutral. To get the correct status, the page needs to be reloaded. (Though nowadays the reload happens automatically for many webpages.)

## Fork information and donations

This is a fork of [cf-detect](https://github.com/traktofon/cf-detect), which is for Firefox-based browsers. Thanks to [traktofon](https://github.com/traktofon) for the base code.  
Right now, the extension is a simple port of the original, with the same features being supported. I plan on working more on this project to port it to Manifest V3 and add some improvements.

Copyright (c) 2017 traktofon, (c) 2024 MassiveBox.  
The software is distributed under the MIT license. Consult the LICENSE file to learn more. 

If you like this fork, consider supporting its creator with a small [donation](https://massivebox.net/pages/donate.html). 
